DECLARE SUB Pause ()
DECLARE SUB RechtsDreh1 (Schritt%)
DECLARE SUB LinksDreh1 (Schritt%)
DECLARE SUB LinksDreh2 (Schritt%)
DECLARE SUB RechtsDreh2 (Schritt%)

'---------------------------------------------------------------------------------
'Dieses Programm beinhaltet alle SUBs, die ntig sind, um eine einafche
'Steuerung der Schrittmotoren zu ermglichen. Eventuell muss der Wert nach
'den OUT Befehlen von &H378 auf &H278 (von PC zu PC unterschiedlich)
'umgestellt werden. Danach sollte alles laufen. Zur berprfung gibt es ein
'ganz simples Programm:
'CLS
'OUT &H378,3
'PRINT INP(&H378)
'OUT &H378
'PRINT INP(&H378)
'Dieses Programm schreibt erst auf die Schnittstelle und liet sie dann wieder
'aus. Sollte beim ersten Auslesen 0 stehen ist die Adresse die &H278.
'(mglich ist auch noch &H3BC). Die Pause muss je nach Schrittmotor angepasst
'werden. Da der TIMER zu langsam ist habe ich die Notlsung mit der FOR-Schleife
'gewhlt (nicht so ganz konform, aber es geht wenigstens).
'---------------------------------------------------------------------------------


CLS

RechtsDreh1 30

LinksDreh1 40

RechtsDreh2 60

LinksDreh2 20

OUT &H378, 0

'(C) by MDM

SUB LinksDreh1 (Schritt%)

FOR Drehen% = 1 TO Schritt%
        OUT &H378, 1 + 8
        Pause
        OUT &H378, 1
        Pause
        OUT &H378, 1 + 2
        Pause
        OUT &H378, 2
        Pause
        OUT &H378, 2 + 4
        Pause
        OUT &H378, 4
        Pause
        OUT &H378, 4 + 8
        Pause
        OUT &H378, 8
        Pause
NEXT Drehen%

END SUB

SUB LinksDreh2 (Schritt%)

FOR Drehen% = 1 TO Schritt%
        OUT &H378, 16 + 128
        Pause
        OUT &H378, 16
        Pause
        OUT &H378, 16 + 32
        Pause
        OUT &H378, 32
        Pause
        OUT &H378, 32 + 64
        Pause
        OUT &H378, 64
        Pause
        OUT &H378, 64 + 128
        Pause
        OUT &H378, 128
        Pause
NEXT Drehen%

END SUB

SUB Pause
FOR a& = 1 TO 5000
NEXT a&
END SUB

SUB RechtsDreh1 (Schritt%)

FOR Drehen% = 1 TO Schritt%
        OUT &H378, 1 + 8
        Pause
        OUT &H378, 8
        Pause
        OUT &H378, 8 + 4
        Pause
        OUT &H378, 4
        Pause
        OUT &H378, 4 + 2
        Pause
        OUT &H378, 2
        Pause
        OUT &H378, 2 + 1
        Pause
        OUT &H378, 1
        Pause
NEXT Drehen%

END SUB

SUB RechtsDreh2 (Schritt%)

FOR Drehen% = 1 TO Schritt%
        OUT &H378, 16 + 128
        Pause
        OUT &H378, 128
        Pause
        OUT &H378, 128 + 64
        Pause
        OUT &H378, 64
        Pause
        OUT &H378, 64 + 32
        Pause
        OUT &H378, 32
        Pause
        OUT &H378, 32 + 16
        Pause
        OUT &H378, 16
        Pause

END SUB

