DECLARE FUNCTION Sekunden! (Start!)
DECLARE SUB Warte (Sek%)
DECLARE SUB ZeitRot (Richtung$, Zeit!)
DECLARE SUB Pause ()
DECLARE SUB RechtsDreh1 (Schritt%)
DECLARE SUB LinksDreh1 (Schritt%)
DECLARE SUB LinksDreh2 (Schritt%)
DECLARE SUB RechtsDreh2 (Schritt%)

'---------------------------------------------------------------------------------
'Dieses Programm beinhaltet alle SUBs, die ntig sind, um eine einafche
'Steuerung der Schrittmotoren zu ermglichen. Eventuell muss der Wert nach
'den OUT Befehlen von &H378 auf &H278 (von PC zu PC unterschiedlich)
'umgestellt werden. Danach sollte alles laufen. Zur berprfung gibt es ein
'ganz simples Programm:
'CLS
'OUT &H378,3
'PRINT INP(&H378)
'OUT &H378
'PRINT INP(&H378)
'Dieses Programm schreibt erst auf die Schnittstelle und liet sie dann wieder
'aus. Sollte beim ersten Auslesen 0 stehen ist die Adresse die &H278.
'(mglich ist auch noch &H3BC). Die Pause muss je nach Schrittmotor angepasst
'werden. Da der TIMER zu langsam ist habe ich die Notlsung mit der FOR-Schleife
'gewhlt (nicht so ganz konform, aber es geht wenigstens).
'
'In diesem Programm sind jetzt noch ein paar SUBs zur leichteren Zeitsteuerung
'
'FUNCTION Sekunden! (Start!) liefert die nach dem setzten von Start! vergangenen
'Sekunden.
'
'SUB Warte (Sek%) wartet die angegebene Anzahl an Sekunden, ohne von der Tastatur
'unterbrochen zu werden (SLEEP)
'
'SUB ZeitRot (Richung$, Zeit%) lsst einen Motor die angegebene Zeit in eine Richtung
'drehen. Mgliche STRINGS:
'                       RechtsDreh1
'                       RechtsDreh2
'                       LinksDreh1
'                       LinksDreh2
'---------------------------------------------------------------------------------

CLS

Start! = TIMER          'Setzten von Start!

RechtsDreh1 30

LinksDreh1 40

RechtsDreh2 60

LinksDreh2 20

PRINT "Die Motoren haben jetzt "; Sekunden!(Start!); " Sekunden gedreht."  'Auslesen der vergangenen Sekunden.

Warte 3                         'jetzt drei Sekunden Warten

ZeitRot "LinksDreh1", 4         'und dann vier Sekunden nach Links drehen.

OUT &H378, 0



'(C) by MDM

SUB LinksDreh1 (Schritt%)

FOR Drehen% = 1 TO Schritt%
        OUT &H378, 1 + 8
        Pause
        OUT &H378, 1
        Pause
        OUT &H378, 1 + 2
        Pause
        OUT &H378, 2
        Pause
        OUT &H378, 2 + 4
        Pause
        OUT &H378, 4
        Pause
        OUT &H378, 4 + 8
        Pause
        OUT &H378, 8
        Pause
NEXT Drehen%

END SUB

SUB LinksDreh2 (Schritt%)

FOR Drehen% = 1 TO Schritt%
        OUT &H378, 16 + 128
        Pause
        OUT &H378, 16
        Pause
        OUT &H378, 16 + 32
        Pause
        OUT &H378, 32
        Pause
        OUT &H378, 32 + 64
        Pause
        OUT &H378, 64
        Pause
        OUT &H378, 64 + 128
        Pause
        OUT &H378, 128
        Pause
NEXT Drehen%

END SUB

SUB Pause
FOR a& = 1 TO 5000
NEXT a&
END SUB

SUB RechtsDreh1 (Schritt%)

FOR Drehen% = 1 TO Schritt%
        OUT &H378, 1 + 8
        Pause
        OUT &H378, 8
        Pause
        OUT &H378, 8 + 4
        Pause
        OUT &H378, 4
        Pause
        OUT &H378, 4 + 2
        Pause
        OUT &H378, 2
        Pause
        OUT &H378, 2 + 1
        Pause
        OUT &H378, 1
        Pause
NEXT Drehen%

END SUB

SUB RechtsDreh2 (Schritt%)

FOR Drehen% = 1 TO Schritt%
        OUT &H378, 16 + 128
        Pause
        OUT &H378, 128
        Pause
        OUT &H378, 128 + 64
        Pause
        OUT &H378, 64
        Pause
        OUT &H378, 64 + 32
        Pause
        OUT &H378, 32
        Pause
        OUT &H378, 32 + 16
        Pause
        OUT &H378, 16
        Pause
NEXT Drehen%

END SUB

FUNCTION Sekunden! (Start!)

Sekunden! = TIMER - Start!

END FUNCTION

SUB Warte (Sek%)

TimeOld! = TIMER
DO
LOOP UNTIL TIMER - TimeOld! > Sek%

END SUB

SUB ZeitRot (Richtung$, Zeit!)
DIM Bit%(1 TO 4)

IF Richtung$ = "LinksDreh1" THEN
        Bit%(1) = 1
        Bit%(2) = 2
        Bit%(3) = 4
        Bit%(4) = 8
        GOTO Rot
END IF

IF Richtung$ = "RechtsDreh1" THEN
        Bit%(1) = 8
        Bit%(2) = 4
        Bit%(3) = 2
        Bit%(4) = 1
        GOTO Rot
END IF

IF Richtung$ = "LinksDreh2" THEN
        Bit%(1) = 16
        Bit%(2) = 32
        Bit%(3) = 64
        Bit%(4) = 128
        GOTO Rot
END IF

IF Richtung$ = "RechtsDreh2" THEN
        Bit%(1) = 128
        Bit%(2) = 64
        Bit%(3) = 32
        Bit%(4) = 16
        GOTO Rot
END IF

GOTO Ende

Rot:

TimeOld! = TIMER

DO
        OUT &H378, Bit%(1) + Bit%(4)
        Pause
        OUT &H378, Bit%(1)
        Pause
        OUT &H378, Bit%(2) + Bit%(1)
        Pause
        OUT &H378, Bit%(2)
        Pause
        OUT &H378, Bit%(2) + Bit%(3)
        Pause
        OUT &H378, Bit%(3)
        Pause
        OUT &H378, Bit%(3) + Bit%(4)
        Pause
        OUT &H378, Bit%(4)
        Pause
LOOP UNTIL TIMER - TimeOld! > Zeit!

Ende:

END SUB

